// This file is @generated by prost-build.
/// Netavark sends the proxy the Network Configuration that it wants to setup
#[derive(serde::Deserialize)]
#[derive(serde::Serialize)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct NetworkConfig {
    #[prost(string, tag = "1")]
    pub host_iface: ::prost::alloc::string::String,
    #[prost(string, tag = "2")]
    pub container_iface: ::prost::alloc::string::String,
    #[prost(string, tag = "3")]
    pub container_mac_addr: ::prost::alloc::string::String,
    #[prost(string, tag = "4")]
    pub domain_name: ::prost::alloc::string::String,
    #[prost(string, tag = "5")]
    pub host_name: ::prost::alloc::string::String,
    #[prost(enumeration = "Version", tag = "6")]
    pub version: i32,
    #[prost(string, tag = "7")]
    pub ns_path: ::prost::alloc::string::String,
    #[prost(string, tag = "8")]
    pub container_id: ::prost::alloc::string::String,
}
/// Lease can either contain a IPv4 or IPv6 DHCP lease, and the common IP information
#[derive(serde::Serialize)]
#[derive(serde::Deserialize)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct Lease {
    #[prost(uint32, tag = "1")]
    pub t1: u32,
    #[prost(uint32, tag = "2")]
    pub t2: u32,
    #[prost(uint32, tag = "3")]
    pub lease_time: u32,
    #[prost(uint32, tag = "4")]
    pub mtu: u32,
    #[prost(string, tag = "5")]
    pub domain_name: ::prost::alloc::string::String,
    #[prost(string, tag = "6")]
    pub mac_address: ::prost::alloc::string::String,
    #[prost(bool, tag = "10")]
    pub is_v6: bool,
    #[prost(string, tag = "11")]
    pub siaddr: ::prost::alloc::string::String,
    #[prost(string, tag = "12")]
    pub yiaddr: ::prost::alloc::string::String,
    #[prost(string, tag = "16")]
    pub srv_id: ::prost::alloc::string::String,
    #[prost(string, tag = "17")]
    pub subnet_mask: ::prost::alloc::string::String,
    #[prost(string, tag = "18")]
    pub broadcast_addr: ::prost::alloc::string::String,
    #[prost(string, repeated, tag = "19")]
    pub dns_servers: ::prost::alloc::vec::Vec<::prost::alloc::string::String>,
    #[prost(string, repeated, tag = "20")]
    pub gateways: ::prost::alloc::vec::Vec<::prost::alloc::string::String>,
    #[prost(string, repeated, tag = "21")]
    pub ntp_servers: ::prost::alloc::vec::Vec<::prost::alloc::string::String>,
    #[prost(string, tag = "22")]
    pub host_name: ::prost::alloc::string::String,
}
/// Empty Message to send when calling for a shutdown
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct Empty {}
/// Response to netavark on successful teardown
#[derive(Clone, Copy, PartialEq, ::prost::Message)]
pub struct OperationResponse {
    #[prost(bool, tag = "1")]
    pub success: bool,
}
#[derive(serde::Serialize)]
#[derive(serde::Deserialize)]
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct NvIpv4Addr {
    #[prost(bytes = "vec", tag = "1")]
    pub octets: ::prost::alloc::vec::Vec<u8>,
}
#[derive(Clone, PartialEq, ::prost::Message)]
pub struct NvIpv6Addr {
    #[prost(bytes = "vec", tag = "1")]
    pub octets: ::prost::alloc::vec::Vec<u8>,
}
#[derive(Clone, Copy, Debug, PartialEq, Eq, Hash, PartialOrd, Ord, ::prost::Enumeration)]
#[repr(i32)]
pub enum Version {
    V4 = 0,
    V6 = 1,
}
impl Version {
    /// String value of the enum field names used in the ProtoBuf definition.
    ///
    /// The values are not transformed in any way and thus are considered stable
    /// (if the ProtoBuf definition does not change) and safe for programmatic use.
    pub fn as_str_name(&self) -> &'static str {
        match self {
            Self::V4 => "V4",
            Self::V6 => "V6",
        }
    }
    /// Creates an enum from field names used in the ProtoBuf definition.
    pub fn from_str_name(value: &str) -> ::core::option::Option<Self> {
        match value {
            "V4" => Some(Self::V4),
            "V6" => Some(Self::V6),
            _ => None,
        }
    }
}
/// Generated client implementations.
pub mod netavark_proxy_client {
    #![allow(
        unused_variables,
        dead_code,
        missing_docs,
        clippy::wildcard_imports,
        clippy::let_unit_value,
    )]
    use tonic::codegen::*;
    use tonic::codegen::http::Uri;
    #[derive(Debug, Clone)]
    pub struct NetavarkProxyClient<T> {
        inner: tonic::client::Grpc<T>,
    }
    impl NetavarkProxyClient<tonic::transport::Channel> {
        /// Attempt to create a new client by connecting to a given endpoint.
        pub async fn connect<D>(dst: D) -> Result<Self, tonic::transport::Error>
        where
            D: TryInto<tonic::transport::Endpoint>,
            D::Error: Into<StdError>,
        {
            let conn = tonic::transport::Endpoint::new(dst)?.connect().await?;
            Ok(Self::new(conn))
        }
    }
    impl<T> NetavarkProxyClient<T>
    where
        T: tonic::client::GrpcService<tonic::body::Body>,
        T::Error: Into<StdError>,
        T::ResponseBody: Body<Data = Bytes> + std::marker::Send + 'static,
        <T::ResponseBody as Body>::Error: Into<StdError> + std::marker::Send,
    {
        pub fn new(inner: T) -> Self {
            let inner = tonic::client::Grpc::new(inner);
            Self { inner }
        }
        pub fn with_origin(inner: T, origin: Uri) -> Self {
            let inner = tonic::client::Grpc::with_origin(inner, origin);
            Self { inner }
        }
        pub fn with_interceptor<F>(
            inner: T,
            interceptor: F,
        ) -> NetavarkProxyClient<InterceptedService<T, F>>
        where
            F: tonic::service::Interceptor,
            T::ResponseBody: Default,
            T: tonic::codegen::Service<
                http::Request<tonic::body::Body>,
                Response = http::Response<
                    <T as tonic::client::GrpcService<tonic::body::Body>>::ResponseBody,
                >,
            >,
            <T as tonic::codegen::Service<
                http::Request<tonic::body::Body>,
            >>::Error: Into<StdError> + std::marker::Send + std::marker::Sync,
        {
            NetavarkProxyClient::new(InterceptedService::new(inner, interceptor))
        }
        /// Compress requests with the given encoding.
        ///
        /// This requires the server to support it otherwise it might respond with an
        /// error.
        #[must_use]
        pub fn send_compressed(mut self, encoding: CompressionEncoding) -> Self {
            self.inner = self.inner.send_compressed(encoding);
            self
        }
        /// Enable decompressing responses.
        #[must_use]
        pub fn accept_compressed(mut self, encoding: CompressionEncoding) -> Self {
            self.inner = self.inner.accept_compressed(encoding);
            self
        }
        /// Limits the maximum size of a decoded message.
        ///
        /// Default: `4MB`
        #[must_use]
        pub fn max_decoding_message_size(mut self, limit: usize) -> Self {
            self.inner = self.inner.max_decoding_message_size(limit);
            self
        }
        /// Limits the maximum size of an encoded message.
        ///
        /// Default: `usize::MAX`
        #[must_use]
        pub fn max_encoding_message_size(mut self, limit: usize) -> Self {
            self.inner = self.inner.max_encoding_message_size(limit);
            self
        }
        ///  Client side streaming to detect client disconnection
        pub async fn setup(
            &mut self,
            request: impl tonic::IntoRequest<super::NetworkConfig>,
        ) -> std::result::Result<tonic::Response<super::Lease>, tonic::Status> {
            self.inner
                .ready()
                .await
                .map_err(|e| {
                    tonic::Status::unknown(
                        format!("Service was not ready: {}", e.into()),
                    )
                })?;
            let codec = tonic::codec::ProstCodec::default();
            let path = http::uri::PathAndQuery::from_static(
                "/netavark_proxy.NetavarkProxy/Setup",
            );
            let mut req = request.into_request();
            req.extensions_mut()
                .insert(GrpcMethod::new("netavark_proxy.NetavarkProxy", "Setup"));
            self.inner.unary(req, path, codec).await
        }
        pub async fn teardown(
            &mut self,
            request: impl tonic::IntoRequest<super::NetworkConfig>,
        ) -> std::result::Result<tonic::Response<super::Lease>, tonic::Status> {
            self.inner
                .ready()
                .await
                .map_err(|e| {
                    tonic::Status::unknown(
                        format!("Service was not ready: {}", e.into()),
                    )
                })?;
            let codec = tonic::codec::ProstCodec::default();
            let path = http::uri::PathAndQuery::from_static(
                "/netavark_proxy.NetavarkProxy/Teardown",
            );
            let mut req = request.into_request();
            req.extensions_mut()
                .insert(GrpcMethod::new("netavark_proxy.NetavarkProxy", "Teardown"));
            self.inner.unary(req, path, codec).await
        }
        pub async fn clean(
            &mut self,
            request: impl tonic::IntoRequest<super::Empty>,
        ) -> std::result::Result<
            tonic::Response<super::OperationResponse>,
            tonic::Status,
        > {
            self.inner
                .ready()
                .await
                .map_err(|e| {
                    tonic::Status::unknown(
                        format!("Service was not ready: {}", e.into()),
                    )
                })?;
            let codec = tonic::codec::ProstCodec::default();
            let path = http::uri::PathAndQuery::from_static(
                "/netavark_proxy.NetavarkProxy/Clean",
            );
            let mut req = request.into_request();
            req.extensions_mut()
                .insert(GrpcMethod::new("netavark_proxy.NetavarkProxy", "Clean"));
            self.inner.unary(req, path, codec).await
        }
    }
}
/// Generated server implementations.
pub mod netavark_proxy_server {
    #![allow(
        unused_variables,
        dead_code,
        missing_docs,
        clippy::wildcard_imports,
        clippy::let_unit_value,
    )]
    use tonic::codegen::*;
    /// Generated trait containing gRPC methods that should be implemented for use with NetavarkProxyServer.
    #[async_trait]
    pub trait NetavarkProxy: std::marker::Send + std::marker::Sync + 'static {
        ///  Client side streaming to detect client disconnection
        async fn setup(
            &self,
            request: tonic::Request<super::NetworkConfig>,
        ) -> std::result::Result<tonic::Response<super::Lease>, tonic::Status>;
        async fn teardown(
            &self,
            request: tonic::Request<super::NetworkConfig>,
        ) -> std::result::Result<tonic::Response<super::Lease>, tonic::Status>;
        async fn clean(
            &self,
            request: tonic::Request<super::Empty>,
        ) -> std::result::Result<
            tonic::Response<super::OperationResponse>,
            tonic::Status,
        >;
    }
    #[derive(Debug)]
    pub struct NetavarkProxyServer<T> {
        inner: Arc<T>,
        accept_compression_encodings: EnabledCompressionEncodings,
        send_compression_encodings: EnabledCompressionEncodings,
        max_decoding_message_size: Option<usize>,
        max_encoding_message_size: Option<usize>,
    }
    impl<T> NetavarkProxyServer<T> {
        pub fn new(inner: T) -> Self {
            Self::from_arc(Arc::new(inner))
        }
        pub fn from_arc(inner: Arc<T>) -> Self {
            Self {
                inner,
                accept_compression_encodings: Default::default(),
                send_compression_encodings: Default::default(),
                max_decoding_message_size: None,
                max_encoding_message_size: None,
            }
        }
        pub fn with_interceptor<F>(
            inner: T,
            interceptor: F,
        ) -> InterceptedService<Self, F>
        where
            F: tonic::service::Interceptor,
        {
            InterceptedService::new(Self::new(inner), interceptor)
        }
        /// Enable decompressing requests with the given encoding.
        #[must_use]
        pub fn accept_compressed(mut self, encoding: CompressionEncoding) -> Self {
            self.accept_compression_encodings.enable(encoding);
            self
        }
        /// Compress responses with the given encoding, if the client supports it.
        #[must_use]
        pub fn send_compressed(mut self, encoding: CompressionEncoding) -> Self {
            self.send_compression_encodings.enable(encoding);
            self
        }
        /// Limits the maximum size of a decoded message.
        ///
        /// Default: `4MB`
        #[must_use]
        pub fn max_decoding_message_size(mut self, limit: usize) -> Self {
            self.max_decoding_message_size = Some(limit);
            self
        }
        /// Limits the maximum size of an encoded message.
        ///
        /// Default: `usize::MAX`
        #[must_use]
        pub fn max_encoding_message_size(mut self, limit: usize) -> Self {
            self.max_encoding_message_size = Some(limit);
            self
        }
    }
    impl<T, B> tonic::codegen::Service<http::Request<B>> for NetavarkProxyServer<T>
    where
        T: NetavarkProxy,
        B: Body + std::marker::Send + 'static,
        B::Error: Into<StdError> + std::marker::Send + 'static,
    {
        type Response = http::Response<tonic::body::Body>;
        type Error = std::convert::Infallible;
        type Future = BoxFuture<Self::Response, Self::Error>;
        fn poll_ready(
            &mut self,
            _cx: &mut Context<'_>,
        ) -> Poll<std::result::Result<(), Self::Error>> {
            Poll::Ready(Ok(()))
        }
        fn call(&mut self, req: http::Request<B>) -> Self::Future {
            match req.uri().path() {
                "/netavark_proxy.NetavarkProxy/Setup" => {
                    #[allow(non_camel_case_types)]
                    struct SetupSvc<T: NetavarkProxy>(pub Arc<T>);
                    impl<
                        T: NetavarkProxy,
                    > tonic::server::UnaryService<super::NetworkConfig> for SetupSvc<T> {
                        type Response = super::Lease;
                        type Future = BoxFuture<
                            tonic::Response<Self::Response>,
                            tonic::Status,
                        >;
                        fn call(
                            &mut self,
                            request: tonic::Request<super::NetworkConfig>,
                        ) -> Self::Future {
                            let inner = Arc::clone(&self.0);
                            let fut = async move {
                                <T as NetavarkProxy>::setup(&inner, request).await
                            };
                            Box::pin(fut)
                        }
                    }
                    let accept_compression_encodings = self.accept_compression_encodings;
                    let send_compression_encodings = self.send_compression_encodings;
                    let max_decoding_message_size = self.max_decoding_message_size;
                    let max_encoding_message_size = self.max_encoding_message_size;
                    let inner = self.inner.clone();
                    let fut = async move {
                        let method = SetupSvc(inner);
                        let codec = tonic::codec::ProstCodec::default();
                        let mut grpc = tonic::server::Grpc::new(codec)
                            .apply_compression_config(
                                accept_compression_encodings,
                                send_compression_encodings,
                            )
                            .apply_max_message_size_config(
                                max_decoding_message_size,
                                max_encoding_message_size,
                            );
                        let res = grpc.unary(method, req).await;
                        Ok(res)
                    };
                    Box::pin(fut)
                }
                "/netavark_proxy.NetavarkProxy/Teardown" => {
                    #[allow(non_camel_case_types)]
                    struct TeardownSvc<T: NetavarkProxy>(pub Arc<T>);
                    impl<
                        T: NetavarkProxy,
                    > tonic::server::UnaryService<super::NetworkConfig>
                    for TeardownSvc<T> {
                        type Response = super::Lease;
                        type Future = BoxFuture<
                            tonic::Response<Self::Response>,
                            tonic::Status,
                        >;
                        fn call(
                            &mut self,
                            request: tonic::Request<super::NetworkConfig>,
                        ) -> Self::Future {
                            let inner = Arc::clone(&self.0);
                            let fut = async move {
                                <T as NetavarkProxy>::teardown(&inner, request).await
                            };
                            Box::pin(fut)
                        }
                    }
                    let accept_compression_encodings = self.accept_compression_encodings;
                    let send_compression_encodings = self.send_compression_encodings;
                    let max_decoding_message_size = self.max_decoding_message_size;
                    let max_encoding_message_size = self.max_encoding_message_size;
                    let inner = self.inner.clone();
                    let fut = async move {
                        let method = TeardownSvc(inner);
                        let codec = tonic::codec::ProstCodec::default();
                        let mut grpc = tonic::server::Grpc::new(codec)
                            .apply_compression_config(
                                accept_compression_encodings,
                                send_compression_encodings,
                            )
                            .apply_max_message_size_config(
                                max_decoding_message_size,
                                max_encoding_message_size,
                            );
                        let res = grpc.unary(method, req).await;
                        Ok(res)
                    };
                    Box::pin(fut)
                }
                "/netavark_proxy.NetavarkProxy/Clean" => {
                    #[allow(non_camel_case_types)]
                    struct CleanSvc<T: NetavarkProxy>(pub Arc<T>);
                    impl<T: NetavarkProxy> tonic::server::UnaryService<super::Empty>
                    for CleanSvc<T> {
                        type Response = super::OperationResponse;
                        type Future = BoxFuture<
                            tonic::Response<Self::Response>,
                            tonic::Status,
                        >;
                        fn call(
                            &mut self,
                            request: tonic::Request<super::Empty>,
                        ) -> Self::Future {
                            let inner = Arc::clone(&self.0);
                            let fut = async move {
                                <T as NetavarkProxy>::clean(&inner, request).await
                            };
                            Box::pin(fut)
                        }
                    }
                    let accept_compression_encodings = self.accept_compression_encodings;
                    let send_compression_encodings = self.send_compression_encodings;
                    let max_decoding_message_size = self.max_decoding_message_size;
                    let max_encoding_message_size = self.max_encoding_message_size;
                    let inner = self.inner.clone();
                    let fut = async move {
                        let method = CleanSvc(inner);
                        let codec = tonic::codec::ProstCodec::default();
                        let mut grpc = tonic::server::Grpc::new(codec)
                            .apply_compression_config(
                                accept_compression_encodings,
                                send_compression_encodings,
                            )
                            .apply_max_message_size_config(
                                max_decoding_message_size,
                                max_encoding_message_size,
                            );
                        let res = grpc.unary(method, req).await;
                        Ok(res)
                    };
                    Box::pin(fut)
                }
                _ => {
                    Box::pin(async move {
                        let mut response = http::Response::new(
                            tonic::body::Body::default(),
                        );
                        let headers = response.headers_mut();
                        headers
                            .insert(
                                tonic::Status::GRPC_STATUS,
                                (tonic::Code::Unimplemented as i32).into(),
                            );
                        headers
                            .insert(
                                http::header::CONTENT_TYPE,
                                tonic::metadata::GRPC_CONTENT_TYPE,
                            );
                        Ok(response)
                    })
                }
            }
        }
    }
    impl<T> Clone for NetavarkProxyServer<T> {
        fn clone(&self) -> Self {
            let inner = self.inner.clone();
            Self {
                inner,
                accept_compression_encodings: self.accept_compression_encodings,
                send_compression_encodings: self.send_compression_encodings,
                max_decoding_message_size: self.max_decoding_message_size,
                max_encoding_message_size: self.max_encoding_message_size,
            }
        }
    }
    /// Generated gRPC service name
    pub const SERVICE_NAME: &str = "netavark_proxy.NetavarkProxy";
    impl<T> tonic::server::NamedService for NetavarkProxyServer<T> {
        const NAME: &'static str = SERVICE_NAME;
    }
}
